	device zxspectrum128
;        ORG #4000
; incbin "corner3.scr"
        ORG #6000
begin

;debug grid
	ld hl,$5800,de,$5803,bc,765:set 6,(hl):ldir
	ld hl,$5800,de,$5801,bc,767,(hl),$44:ldir

ppl	equ $B000
sqat equ $A000 ; screen address table
asat equ ppl+$600 ;attribute screen address table
;generate data for plot
	ld hl,st,de,ppl,bc,256:ldir
	LD DE,#4000,BC,#8000,L,E
FLP1    LD H,1+high ppl
        LD (HL),C
        INC H
        LD (HL),E
        INC H
        LD (HL),D
        INC H
        LD (HL),B
        RRC B
        LD A,C:ADC A,0:LD C,A
FBR1    INC D:LD A,D:AND 7
        JR NZ,FNXT:LD A,E:ADD A,32
        LD E,A:JR C,FNXT
        LD A,D:SUB 8:LD D,A
FNXT    INC L:JR NZ,FLP1
;build sq data
	ld hl,ppl+1024
;	jr $

bsql:
	ld c,(hl),d,c,e,0
	ld b,7
bs1:
	or a
	rr d
	rr e
	ld a,d
	or c
	ld d,a
	djnz bs1
	ld (hl),d:inc h
	ld (hl),e:dec h

	inc l:jr nz,bsql
;fill table
	ld hl,sqat
ftl:
	ld (hl),$05:inc l
	ld (hl),$40:inc l
	jr nz,ftl
;	jr $
;attribute data - $B600-$B7FF
	ld hl,asat,de,$5800,c,e
gena:
	push hl
	ld (hl),c:inc h
	ld (hl),e:inc h
	ld (hl),d:inc h
	pop hl
	inc l
	ld a,l
	and 7
	jr nz,nocha
	inc c
	push bc
	ex de,hl
	ld bc,32
	add hl,bc
	ex de,hl
	pop bc
nocha:
	inc l
	dec l
	jr nz,gena
;;;;;;;;;;;;;;;;S T A R T;;;;;;;;;;;;;;;;
;	jr $
zu: ei:halt
	ld a,0:out ($FE),a
sv: ld a,-1
	inc a
	ld (sv+1),a
	ld c,a
	ld (backsp+1),sp
	ld sp,sqat
	ld a,16
	exx
	ld hl,colt
	exx
slp:
	exa
;zero previous square
	xor a
	dup 8
	pop hl
	ld (hl),a
	inc l
	ld (hl),a
edup
	ld h,ppl/256
	ld l,c
	ld a,(hl)
	add a,32
	ld e,a
	ld a,l
	add a,64
	ld l,a
	ld d,(hl)
;draw attribute
	ld h,asat/256
	ld l,e
	ld a,(hl)
	ld l,d
	inc h
	add a,(hl)
	ld ixl,a
	inc h
	ld a,(hl)
	ld ixh,a
	exx
	ld a,(hl)
	inc hl
	exx
	ld (ix+0),a
	ld (ix+1),a
	ld (ix+32),a
	ld (ix+33),a

;
	ld h,1+ppl/256;inc h
	ld l,e
	ld a,(hl)
	inc h
	ld l,d
	add a,(hl)
	inc h
	ld d,(hl)
	ld l,e
	ld e,a
	inc h
	ld a,(hl)
	inc h
	ld l,(hl)
	ld h,a
	ex de,hl
;put square
	dup 4
	push hl
	ld (hl),d:inc l
	ld (hl),e

	INC h:LD A,h
	AND 7:jr nz,$+12
	LD A,L:ADD A,#20:LD L,A:jr c,$+6
	LD A,H:SUB 8:LD H,A

	ld (hl),e:dec l
	ld (hl),d

	push hl

	INC h:LD A,h
	AND 7:jr nz,$+12
	LD A,L:ADD A,#20:LD L,A:jr c,$+6
	LD A,H:SUB 8:LD H,A
edup
	ld hl,16
	add hl,sp
	ld sp,hl
	ld a,c
	add a,16
	ld c,a
	exa
	dec a
	jp nz,slp
backsp:ld sp,0
	ld a,7:out ($FE),a
	jp zu
;
colt:
	db 1,2,3,4,5,6,7,1
	db 2,3,4,5,6,7,1,2
;	db 3,4,5,6,7,1,2,3

st:incbin "pl.data"
end
	display /d,end-begin
	savesna "!void.sna",begin

