    device zxspectrum128
        ORG #6000
begin
qt:
 db $00,$01,$02,$09,$10,$19,$24,$31
 db $40,$51,$64
 db $79,$35,$38,$47,$38,$98,$5F,$47
runi:
;	out ($FE),a
;testdraw
;	ld hl,chu,de,$4000
;td1:
;	push de
;	ld b,8
;td2:
;	ld a,(hl),(de),a
;	inc hl,d
;	djnz td2
;	pop de
;	inc e
;	jr nz,td1
;	jr $
	
	ld hl,$5800,de,$5801,bc,767,(hl),$47:ldir

	ld a,$10,bc,$7ffd:out (c),a
;zero memory
	ld hl,$A000
	ld c,l
zm:
	ld (hl),c
	inc l
	jr nz,zm
	inc h
	jr nz,zm

bsin equ $9E00
	ld hl,st,de,bsin,bc,256:ldir
chp=$B000

    ld hl,chp
    ld de,chu
mk:
    push hl
    ld b,8
m1:
    ld a,(de),(hl),a
    inc de,h
    djnz m1
    pop hl
    inc l
    bit 6,l
    jr z,mk
    
    ld b,8
    ld de,hl
    dec de
m2:
    push de,hl
m3:
    ld a,(de),(hl),a
    inc l
    dec e
    jr nz,m3
    pop hl,de
    inc h,d
    djnz m2

    ld a,8
    ld hl,chp
m4:
    ld d,h
    ld e,$80
    push hl
    ld bc,128
    ldir
    pop hl
    inc h
    dec a
    jr nz,m4
;copy color
	ld de,chp+$800
	ld hl,col_b
	ld bc,col_e-col_b
	ldir
;copy routine
	ld hl,check_b
	ld de,check_e
	ld bc,255*(check_e-check_b)
	ldir
	ld a,$C9,(de),a
;	inc de
;	ld (pp+1),de

;calc a^2
;generate square circle
bp=$9F00 ; blob place
	ld hl,bp
	ld b,16
gc1:
	ld c,16
gc2:
	ld a,c
	sub 8
	jr nc,nom1
	neg
nom1:
	ld e,a
	ld d,qt/256
	ld a,(de)
	push af

	ld a,b
	sub 8
	jr nc,nom2
	neg
nom2:
	ld e,a
	ld d,qt/256
	ld a,(de)

	ld e,a
	ld (hl),0
	pop af
	add a,e
	cp 32+2
	jr nc,next
	xor 31
	ld (hl),a
next:
	inc hl
	dec c
	jr nz,gc2
	djnz gc1

;*************************************************
zu:
	ei
	halt
;pg:
;	ld a,$17
;	ld bc,$7ffd
;	out (c),a
;	xor $0A
;	ld (pg+1),a
	
;	ld a,(v1+2):xor $80:ld (v1+2),a
;	ld a,(v2+2):xor $80:ld (v2+2),a
;###############################################
	ld hl,$A400
	ld de,$A000
	exx
v1:	ld hl,$5800
v2:	ld de,$4000
	exx
	call check
	inc h,d
	exx
	inc h
	ld a,d:add a,8:ld d,a
	exx
	call check
	inc h,d
	exx
	inc h
	ld a,d:add a,8:ld d,a
	exx
	call check

	call blob

	jp zu
;---------------------------------------------------
blob:
	ld hl,$A000,de,$A001,(hl),l,bc,767:ldir

v_1: ld a,0
	add a,3
	ld (v_1+1),a
	ld l,a,h,bsin/256
	ld e,(hl),d,$A0
	call addblo
;	ld de,$A024
v_2: ld a,0
	add a,7
	ld (v_2+1),a
	ld l,a,h,bsin/256
	ld a,(hl)
	srl a
	ld l,a,h,0,de,$A000
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	ex de,hl
	call addblo
	ret

addblo:
	ld hl,bp
	ld a,16
ba1:
	push de
	exa
	ld b,16
ba2:
	ld a,(de)
	add a,(hl):inc hl
	ld (de),a:inc de
	djnz ba2
	pop de
	ld bc,32
	ex de,hl
	add hl,bc
	ex de,hl
	exa
	dec a
	jr nz,ba1
	ret

;---------------------------------------------------
check:
check_b:
	ld a,(de)
	cp (hl)
	ld (hl),a
	exx
	jr z,skipy
;hl=atr
;de=scr
	ld c,a
	ld b,chp/256
 dup 7
 	ld a,(bc)
 	ld (de),a
 	inc b
 	inc d
edup
 	ld a,(bc)
 	ld (de),a

	inc b
 	ld a,(bc)
 	ld (hl),a
 	ld a,d
 	sub 7
 	ld d,a
skipy:
	inc l
	inc e
	exx
	inc e
	inc l
check_e:

chu:incbin "bn_tile.bin"
st:incbin "blobsin.bin"
col_b:
 db 0,1,1,1,1,1,1,1
 db 2,2,2,2,2,2,2,2
 db 3,3,3,3,3,3,3,3
 db 4,4,4,4,4,4,4,4
 db 5,5,5,5,5,5,5,5
 db 6,6,6,6,6,6,6,6
 db 7,7,7,7,7,7,7,7
; db 00,01,01,01,01,01,01,01,03,03,03,03,03,03,03,03,02,02,02,02,02,02,02,02,05,05,05,05,04,04,04,04
; db 06,06,06,06,06,06,06,06,04,04,04,04,05,05,05,05,02,02,02,02,02,02,02,02,03,03,03,01,01,01,01,00
 dup 64
 db 7
edup

 dup 64
 db 7
edup

 dup 64
 db 7
edup
col_e:

end
    display /d,end-begin
    savesna "!void.sna",runi

