 DEFINE rel ;comment for sna,un for code

	device zxspectrum128
        ORG #6000
begin

sa	equ $B000 ; screen address
bw	equ $B800
	ld a,5:call fila
;generate data for output
	ld hl,bw
genlp:
	ld a,l
	ld b,8
	push hl
ge2:
	add a,a
	push af
	sbc a,a
	and 63
	or 5
	ld (hl),a
	inc h
	pop af
	djnz ge2
	pop hl
	inc l
	jr nz,genlp
;generate screen table
	ld hl,sa
	ld de,$4000
gst:
	ld (hl),e:inc h
	ld (hl),d:dec h
	ld a,e
	add a,32
	ld e,a
	sbc a,a
	and 8
	add a,d
	ld d,a
	inc l
	jr nz,gst
;prepare table
	ld ix,spat;y,dy,c
	ld b,32
ptlp:
	call reinit
	inc ix,ix,ix
	djnz ptlp

zu:
	ei:halt
	ld a,(notecnt)
;	out ($FE),a
	cp $10:jp z,blackscr
;	ld a,0:out ($FE),a
	call freako
;	ld a,7:out ($FE),a
sva1: ld a,0
	inc a
	ld (sva1+1),a
	and 1
	call z,sparx
;	ld a,4:out ($FE),a
	jp zu

reinit:
	ld (ix+0),23
	ld a,r
	and 1
	inc a
	neg
	ld (ix+1),a
getc:ld a,r
	and 15
	jr z,getc
	ld (ix+2),a
	ret
sparx:
	ld ix,spat;y,dy,c
	ld b,0
spalp:
;erase previous
	ld l,(ix+0)
	ld h,sa/256
	ld a,(hl)
	inc h
	ld h,(hl)
	add a,b
	ld l,a
 dup 8
 	ld (hl),0:inc h
edup
	ld a,(ix+0)
	add a,(ix+1)
	ld (ix+0),a
	jp p, okatscr
	call reinit
okatscr:
;	jr $
	ld a,(ix+2)
	dec a
	ld (ix+2),a
	call z,reinit
;draw
	ld a,(ix+2)
	ld l,a,h,0
	ld de,pat
	add hl,hl
	add hl,hl
	add hl,hl
;	add hl,hl
	add hl,de
	ex de,hl
;draw
	ld l,(ix+0)
	ld h,sa/256
	ld a,(hl)
	inc h
	ld h,(hl)
	add a,b
	ld l,a
 dup 8
 	ld a,(de),(hl),a:inc h,de
edup
	inc ix,ix,ix
	inc b
	bit 5,b
	jp z,spalp
	ret

freako:
fv1: ld a,-1
	inc a
	ld (fv1+1),a
	and 15+16
	srl a
	srl a
	srl a
	ld de,fs
	ld l,a,h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	ld de,$588C
	ld a,16
fo:
	exa
	ld b,bw/256
	ld c,(hl)
	inc hl
 dup 8
 	ld a,(bc)
 	ld (de),a
 	inc b
 	inc e
edup
	ld bc,32-8
	ex de,hl
	add hl,bc
	ex de,hl
	exa
	dec a
	jp nz,fo
	ret
fs:incbin "freaks.bin"
pat:incbin "dither.bin"

 IFNDEF rel
 include "../utils.inc"
 ELSE
 include "../demovars.inc"
 ENDIF
;y,dy,c
spat:
end
	display/d, end-begin
 IFNDEF rel
	savesna "freak.sna",begin
 ELSE
	savebin "05freak.code",begin,end-begin
 ENDIF
