 DEFINE rel ;comment for sna,un for code

	device zxspectrum128
        ORG #6000
begin
;	ld hl,$5800,de,$5803,bc,765:set 6,(hl):ldir
ei
	ld hl,$5800,de,$5801,bc,512,(hl),$0E:ldir
	ld bc,255,(hl),$0D:ldir
	
	ei
	ld a,$10:call bank01
;out logo
	ld hl,tt,de,$C000:call dzx7_standard
	ld hl,$C000,de,$4040
	ld a,96
drl:
	exa
	push de
	ld bc,32:ldir
	pop de
	call nbde
	exa
	dec a
	jr nz,drl
;generate table
wts equ $B000
buf equ $BF00
ppl equ wts+256
	ld hl,ws,de,wts,bc,256:ldir
;	ld a,$10,bc,$7ffd:out (c),a
;	ld hl,$C000,de,$C001,bc,2047,(hl),l:ldir
;zero memory
	ld hl,$C000
zm:	ld (hl),0
	inc l
	jr nz,zm
	inc h
	jr nz,zm

;stack routine
	ld bc,$C000
	ld hl,ou
	ld de,$5000
fo1:
	ld (hl),$31:inc hl
	ld (hl),c:inc hl
	ld (hl),b:inc hl
	push de
fo2:
	ld (hl),$e1:inc hl
	ld (hl),$22:inc hl
	ld (hl),e:inc hl
	ld (hl),d:inc hl
	inc e,e
	ld a,e
	and 31
	jr nz,fo2
	push bc
	ld b,16
fo3:
	ld (hl),$D5:inc hl
	djnz fo3

	pop bc
	pop de
	call nbde
	inc b
	jr nz,fo1
;	ld bc,1024
;fo3:
;	ld (hl),$D5:inc hl
;	dec bc
;	ld a,b:or c
;	jr nz,fo3
	ld (hl),$31:inc hl
	ld (ous+2),hl
	inc hl,hl
	ld (hl),$C9:inc hl

wa:ei:halt
;	ld a,7:out ($FE),a
	call ous
;	ld a,0:out ($FE),a
wav:	ld de,0
	inc e,e,e
	dec d,d
	ld (wav+1),de
	ld bc,$8000
pixl:
	ld h,wts/256
	ld l,e
	ld a,(hl)
;	srl a
	ld l,d
	add a,(hl)
	and 63
	or $C0
	ld h,a
	ld l,c
	ld a,(hl)
	or b
	ld (hl),a
	inc e
	dec d,d
	rrc b
	ld a,c
	adc a,0
	ld c,a
	cp 32
	jp nz,pixl
;eorfill
	ld l,00
eof:
	ld h,$C0
	ld a,(hl)
	inc h
	dup 63
	xor (hl)
	ld (hl),a
	inc h
edup
	inc l
	bit 5,l
	jp z,eof
;	ld a,6:out ($FE),a

	jp wa
;	ld hl,$C000
;	ld de,$5000
;cop:
;	push hl,de
;	ld bc,32
;	ldir
;	pop de,hl
;	call nbde
;	inc h
;	jr nz,cop
;	jr $

 IFNDEF rel
 include "../utils.inc"
 ELSE
 include "../demovars.inc"
 ENDIF

ous: ld (0),sp
	ld de,0
ou:
ws:incbin "wavysin.bin"
tt: incbin "does.bin.zx7"
end
	display /d,end-begin
 IFNDEF rel
	savesna "wavy.sna",begin
 ELSE
	savebin "12finale.code",begin,end-begin
 ENDIF
