 DEFINE rel ;comment for sna,un for code

	device zxspectrum128
        ORG #6000
begin

tp equ $AF00;sin,patterns
buf equ tp+$900
	ld a,$47:call fila
	ld hl,cst,de,tp,bc,256:ldir
	ld hl,buf,de,buf+1,bc,767,(hl),0:ldir
;copy tiles, 32
	ld hl,tp+256
copyt:
	ld de,pat
ct1:
	ld b,8
	push hl
ct2:
	ld a,(de),(hl),a
	inc de,h
	djnz ct2
	pop hl
	inc l
	ld a,l
	and 31
	jr nz,ct1
	ld a,l
	or a
	jp nz,copyt

;	ld hl,$4000,de,$4001,bc,6143,(hl),$AA:ldir
	ld hl,dr_b,de,dr_e,bc,255*(dr_e-dr_b):ldir
	ld a,$C9,(de),a
;	jr $
mu: ei:halt
;	ld a,(notecnt) ;$10;$11;$12;$13
;	out ($FE),a
coop:call sy1
;vis
	ld hl,buf
	ld de,$4000
	call dr_b
	ld de,$4800
	call dr_b
	ld de,$5000
	call dr_b

;do it
	ld hl,table
	ld de,tp
	exx
	ld hl,buf
	exx
dolp:
;For y=0 To 23
;  For x=0 To 31

;    an.a=t1(x,y)+da
	ld a,(hl)
v_an: add a,0
;	ld (hl),a
	inc hl
	ld e,a

;    ra.a=t2(x,y)+dr
	ld a,(hl)
v_ra: add a,0
;	ld (hl),a
	inc hl
	ld b,a

;    co.a=(s(an)!c(an))&ra;&
	ld a,(de)
	ld c,a
	ld a,e:add a,64:ld e,a
	ld a,(de)

;0 op1=xor c,op2=and b
;1 op1=and c
;3 op2=add a,c
op1:	xor c
op2:	and b

	exx
	ld (hl),a
	inc hl
	ld a,h
	exx
	cp 3+buf/256
	jp nz,dolp
;  Next x
;Next y
;    da=da+7
	ld a,(v_an+1)
	add a,7
	ld (v_an+1),a
;    dr=dr+2
	ld a,(v_ra+1)
	add a,2
	ld (v_ra+1),a
	jp mu
;############################# SYNC #############################
sy1:
	ld a,(notecnt)
	cp $10:ret z
	ld hl,sy2,(coop+1),hl
	ld a,$A1,(op1),a
	ret
sy2:
	ld a,(notecnt)
	cp $11:ret z
	ld hl,sy3,(coop+1),hl
	ld a,$81,(op2),a
	ret
sy3:
	ld a,(notecnt)
	cp $14:ret nz
	pop af
	jp blackscr;ret

table: incbin "cooldata.bin"
cst: incbin "coolsin.bin"
;pat:incbin "reduced.bin"
pat:incbin "4400.002"
 IFNDEF rel
 include "../utils.inc"
 ELSE
 include "../demovars.inc"
 ENDIF
dr_b:
	ld b,1+tp/256
	ld c,(hl)
	inc hl
 dup 8
 ld a,(bc),(de),a
 inc b,d
edup
	inc e
	ld a,d
	sub 8
	ld d,a
dr_e:
end
	display /d,end-begin
 IFNDEF rel
	savesna "cool.sna",begin
 ELSE
	savebin "06cool.code",begin,end-begin
 ENDIF
