	device zxspectrum128
        ORG #6000
begin
;st:incbin "sintable.data"
runi:
;	ld sp,$5FE0
;prepare texture
	ld a,$10,bc,$7ffd:out (c),a

	ld hl,st,de,$BE00,bc,512:ldir
;black screen
;    ld hl,$5AFF,de,$5AFE,bc,$1B00-1,(hl),0:lddr

;draw grid
;	ld hl,$4000
;dg1:
;	ld a,h
;	rra
;	sbc a,a
;	xor $aa
;dg2:
;	ld (hl),a
;	inc l
;	jr nz,dg2
;	inc h
;	ld a,h
;	cp $58
;	jr nz,dg1


;copy smile
	ld de,sm
	ld h,$C0
cs1:
	ld l,0
cs2:
	ld a,(de)
	inc de
;	and 7
;	add a,a
;	add a,a
;	add a,a
	or a
	jr z,putv
	ld a,255
putv:
;	cpl
	ld (hl),a
	inc l
	bit 5,l
	jr z,cs2
	inc h
	ld a,h
	cp $D0
	jr nz,cs1

	ld h,$C0
cs3:
	ld l,0
	ld e,32
	push hl
	ld d,h
	ld bc,256-32
	ldir
	pop hl
	inc h
	jr nz,cs3
	ld hl,$C000
	ld de,$D000
	ld bc,$2FFF+1
	ldir
mm:
	ei
	halt
an1: ld a,-1
	inc a
	ld (an1+1),a
; zx.w = sin_table(an)
	ld h,$BE;st/256
	ld l,a
	ld e,(hl)
	inc h
	ld d,(hl)
	ld (zx),de
; zy.w = cos_table(an)
	ld a,l
	add a,64
	ld l,a
	ld d,(hl)
	dec h
	ld e,(hl)
	ld (zy),de

;{ centrowanie }
;height=32
;width=24
; fx_.w = -((height/2)*(zx+zy))
	ld hl,(zx)
	ld de,(zy)
	add hl,de
;*16
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld a,h:cpl:ld h,a
	ld a,l:cpl:ld l,a
	inc hl
;	ld bc,60:add hl,bc
	ld (fx_),hl
; fy_.w = -((width/2)*(zx-zy))
 	ld hl,(zx)
 	ld de,(zy)
 	or a
 	sbc hl,de
;*12
	ld de,hl
	add hl,hl
	add hl,de;*3
	add hl,hl
	add hl,hl

;	ld bc,32:add hl,bc
	ld (fy_),hl

;	ld bc,$5800
; bw=8;+12
; StartDrawing(ScreenOutput())
;  For j = 0 To height-1
;	ld (back_sp+1),sp
;	ld sp,$5B00
;	ld a,24
	ld bc,$4000
va: ld a,-1
	inc a
	ld (va+1),a
	and 7
	or b
	ld b,a
rzlp:
;	exa
;  fx.w = fx_
;  fy.w = fy_
	ld hl,(fx_)
	ld de,(zx)
	exx
	ld hl,(fy_)
	ld de,(zy)
	ld a,d:cpl:ld d,a
	ld a,e:cpl:ld e,a
	inc de
	exx

 dup 32
;  For i = 0 To width-1
;    ;pixels[i,j] = texture[(fx >> 8) mod 64 , (fy >> 8) mod 64]
;    ;c.a=(fx!fy)>>8
;    c.l=tt((fx>>8)&31,(fy>>8)&31)
;    Box(j*bw,i*bw,bw,bw,c);RGB(c,c,c))
;   fx = fx+zx
	add hl,de
	ld a,h
	exx
	ld c,a
	ld a,h
;	and 63
	or $C0
	ld b,a
	ld a,(bc)
;   fy = fy-zy
	add hl,de
	exx
;	ld b,a
	ld (bc),a
	inc c
;	add hl,de
;	ld a,h
;	exx
;	ld c,a
;	ld a,h
;;	and 63
;	or $C0
;	ld b,a
;	ld a,(bc)
;;   fy = fy-zy
;	add hl,de
;	exx
;	ld c,a
;	push bc
; Next i
edup

;  fx_ = fx_+zy
	ld hl,(fx_)
	ld de,(zy)
	add hl,de
	ld (fx_),hl
;  fy_ = fy_+zx
	ld hl,(fy_)
	ld de,(zx)
	add hl,de
	ld (fy_),hl
	
	inc c
	dec c
	jp nz,rzlp
;	jr $
	ld a,b
	add a,8
	ld b,a
	cp $58
	jp c,rzlp
;	exa
;	dec a
;	jp nz,rzlp
;Next j
;back_sp:ld sp,0
	jp mm

;brd:
;	jr $
;	push af
;	ld a,$7F
;	in a,($FE)
;	rra
;	jr c,exbrd
;	pop af
;	out (c),a
;	push af
;exbrd:
;	pop af
;	ret
	
zx: dw 0
zy: dw 0
fx_:dw 0
fy_:dw 0

sm:incbin "smile1.bin"
st:incbin "sintable.data"
end
	display end
	display /d,end-begin
	savesna "!void.sna",runi;begin

